unit Unit1;

{$mode delphi}

interface

uses
  JwaWindows, Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Image1: TImage;
    ListBox1: TListBox;
    Splitter1: TSplitter;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1SelectionChange(Sender: TObject; {%H-}User: boolean);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

type
  PListBox = ^TListBox;

function GetWindows(const AHWND: Longword; AListBox: PListBox): LongBool; stdcall;
var
  SLength: Longint;
  S: String;
begin
  Result := True;
  if not (IsWindow(AHWND) and IsWindowVisible(AHWND)) then Exit;
  SLength := SendMessage(AHWND, WM_GETTEXTLENGTH, 0, 0);
  if SLength > 0 then
  begin
    SetLength(S{%H-}, SLength);
    SendMessage(AHWND, WM_GETTEXT, SLength + 1, {%H-}LPARAM(PChar(S)));
    AListBox^.Items.AddObject(s, TObject(AHWND));
  end;
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  AListBox: PListBox;
begin
  AListBox := @ListBox1;
  EnumWindows(@GetWindows, {%H-}LPARAM(AListBox));
end;

procedure TForm1.ListBox1SelectionChange(Sender: TObject; User: boolean);
var
  AHandle: THandle;
  ARect: TRECT;
begin
  Caption := '[' + IntToStr(Integer(ListBox1.Items.Objects[ListBox1.ItemIndex])) + '] ' + ListBox1.Items[ListBox1.ItemIndex];
  AHandle := Integer(ListBox1.Items.Objects[ListBox1.ItemIndex]);
  ARect := Rect(0, 0, 0, 0);
  GetWindowRect(AHandle, ARect);
  Image1.Picture.Bitmap.SetSize(0, 0);
  Image1.Picture.Bitmap.SetSize(ARect.Width, ARect.Height);
  PrintWindow(AHandle, Image1.Picture.Bitmap.Canvas.Handle, PW_CLIENTONLY);
end;

end.

